=== modified file 'bzrlib/tests/blackbox/test_merge.py'
--- bzrlib/tests/blackbox/test_merge.py	2007-12-08 01:00:58 +0000
+++ bzrlib/tests/blackbox/test_merge.py	2007-12-09 20:58:03 +0000
@@ -417,5 +417,5 @@
         other_tree.commit('rev2b')
         self.build_tree_contents([('other/file', "c\na\nb\n")])
         other_tree.commit('rev3b')
-        self.run_bzr('merge --weave -d this other -c -1')
+        self.run_bzr('merge --weave -d this other -r -2..-1')
         self.assertFileEqual('c\na\n', 'this/file')

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2007-12-04 03:54:55 +0000
+++ bzrlib/tests/test_merge.py	2007-12-09 20:58:03 +0000
@@ -288,6 +288,24 @@
         merger.do_merge()
         self.assertEqual(tree_a.get_parent_ids(), [tree_b.last_revision()])
 
+    def test_weave_cherrypick(self):
+        this_tree = self.make_branch_and_tree('this')
+        self.build_tree_contents([('this/file', "a\n")])
+        this_tree.add('file')
+        this_tree.commit('rev1')
+        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
+        self.build_tree_contents([('other/file', "a\nb\n")])
+        other_tree.commit('rev2b', rev_id='rev2b')
+        self.build_tree_contents([('other/file', "c\na\nb\n")])
+        other_tree.commit('rev3b', rev_id='rev3b')
+        this_tree.lock_write()
+        self.addCleanup(this_tree.unlock)
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
+            this_tree, 'rev3b', 'rev2b', other_tree.branch)
+        merger.merge_type = _mod_merge.WeaveMerger
+        merger.do_merge()
+        self.assertFileEqual('c\na\n', 'this/file')
+
 
 class TestPlanMerge(TestCaseWithMemoryTransport):
 

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2007-12-08 00:57:27 +0000
+++ bzrlib/tree.py	2007-12-09 20:58:03 +0000
@@ -306,7 +306,7 @@
         if base is None:
             last_revision_base = None
         else:
-            last_revision_base = other._get_file_revision(file_id, vf, 'base:')
+            last_revision_base = base._get_file_revision(file_id, vf, 'base:')
         return vf.plan_merge(last_revision_a, last_revision_b,
                              last_revision_base)
 

